#include <bits/stdc++.h>
using namespace std;
using namespace std;
typedef long long ll;
typedef vector <int> vi;
typedef pair <int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<ll> vll;
#define A first
#define B second
#define PB push_back
#define MP make_pair
#define all(v) v.begin(),v.end()
#define FAST ios_base::sync_with_stdio(false),cin.tie(0),cout.tie(0);

int main()
{
    FAST
    int n,m;
    cin>>n>>m;
    int a[n];
    set<int> s;
    for(int i=0;i<n;i++)
    {
        int u;
        cin>>a[i]>>u;
        s.insert(a[i]);
    }
    map<pair<int,int>,int> r;
    for(auto x:s)
    {
        if(a[0]=x) r[MP(x,0)]=1;
        for(int i=1;i<n;i++)
        {
            r[MP(x,i)]=r[MP(x,i-1)];
            if(a[i]==x) r[MP(x,i)]++;
        }
    }
    for(int i=0;i<m;i++)
    {
        int x,p,q;
        cin>>p>>q>>x;
        p--;
        q--;
        if(q<p) swap(p,q);
        cout<<r[MP(x,q)]-r[MP(x,p)]<<endl;
    }
    return 0;
}